/* gtamilocr.cpp. This file is part of GNU Tamil OCR
 *
 * GNU Tamil OCR :  <http://gtamilocr.sourceforge.net>
 * Free, Cross-Platform, Optical Character Recognition for Tamil
 *
 * Copyright (C) 2004-2007  Visweswara R, <visweswara@users.sourceforge.net>.
 * All Rights Reserved. DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR
 * THIS FILE HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License version 3 for more details(a copy is included
 * in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contributions: GUI enhancement, splash screen ,noise removal functions
 * by Janagaraj V,janagaraj@users.sourceforge.net
 */

#include "gtamilocr.h"
///debug function
MyFrame* logwin;
wxLogWindow *lg;
wxFFile filr;
wxTextCtrl* logtext;
wxLog  *logtarget;
////debugfunction


BEGIN_EVENT_TABLE(MyFeatureDialog,wxDialog)
END_EVENT_TABLE()

MyFeatureDialog::MyFeatureDialog( wxWindow *parent, wxWindowID id, const wxString &title,
    const wxPoint &position, const wxSize& size, long style ) :
    wxDialog( parent, id, title, position, size, style )
{
    //   dialog function Features Select for MyFeatureDialog
    //Features_Select( this, TRUE );
}

//------------------------------------------------------------------------------
// MyTamilFrame
//------------------------------------------------------------------------------

//   event table for MyTamilFrame

BEGIN_EVENT_TABLE(MyTamilFrame,wxFrame)

    EVT_MENU(ID_ABOUT, MyTamilFrame::OnAbout)
    EVT_MENU(ID_QUIT, MyTamilFrame::OnQuit)
    EVT_CLOSE(MyTamilFrame::OnCloseWindow)
    EVT_SIZE(MyTamilFrame::OnSize)
    EVT_MENU( ID_FEATURE, MyTamilFrame::OnFeature )
    EVT_MENU( ID_ABOUT, MyTamilFrame::OnAbout )
    EVT_MENU( ID_OPEN, MyTamilFrame::OnOpen )
    EVT_MENU( ID_SAVE_IMAGE, MyTamilFrame::OnSave )
    EVT_MENU( ID_SAVEIMAGEAS, MyTamilFrame::OnSaveimageas )
    EVT_MENU( ID_SAVETEXTAS, MyTamilFrame::OnSavetextas )
    EVT_MENU( ID_READ, MyTamilFrame::OnRead )
    EVT_MENU( ID_BATCH, MyTamilFrame::OnBatch )
    EVT_MENU( ID_OPTIONS, MyTamilFrame::OnOptions )
    EVT_MENU( ID_CLEAR, MyTamilFrame::OnClear )
    EVT_MENU( ID_REVIMAGE, MyTamilFrame::OnRevimage )
    EVT_MENU( ID_90, MyTamilFrame::OnRotate90 )
    EVT_MENU( ID_180, MyTamilFrame::OnRotate180 )
    EVT_MENU( ID_270, MyTamilFrame::OnRotate270 )
    EVT_MENU( ID_SKEW, MyTamilFrame::OnSkew )
    EVT_MENU( ID_FEATURE, MyTamilFrame::OnFeature )
    EVT_MENU( ID_ZOOMIN, MyTamilFrame::OnZoomin )
    EVT_MENU( ID_ZOOMOUT, MyTamilFrame::OnZoomout )
    EVT_MENU( ID_FIT, MyTamilFrame::OnFit )
	EVT_MENU( ID_FONTS, MyTamilFrame::OnFont )
    EVT_MENU( ID_SEGMENT, MyTamilFrame::OnSegment )
    EVT_MENU( ID_USING, MyTamilFrame::OnUsinghelp )
    EVT_TOOL( ID_TOOLOPEN, MyTamilFrame::OnOpen )
    EVT_TOOL( ID_TOOLSAVE, MyTamilFrame::OnSave )
	EVT_TOOL( ID_TOOLSAVEAS, MyTamilFrame::OnSaveimageas )
    EVT_TOOL( ID_TOOLZOOMIN, MyTamilFrame::OnZoomin )
	EVT_TOOL( ID_TOOLZOOMOUT, MyTamilFrame::OnZoomout )
    EVT_TOOL( ID_TOOLSKEW, MyTamilFrame::OnSkew )
	EVT_TOOL( ID_TOOLREAD, MyTamilFrame::OnRead )

END_EVENT_TABLE()

MyTamilFrame::MyTamilFrame( wxWindow *parent, wxWindowID id, const wxString &title,
    const wxPoint &position, const wxSize& size, long style ) :
    wxFrame( parent, id, title, position, size, style )
{
    CreateMyMenuBar();
    CreateMyToolBar();
    CreateStatusBar(1);
    SetStatusText( wxT("Welcome To GNU Tamil OCR") );

	 imagebox=new MyImageBox(this,-1,wxT("Imagebox"),wxDefaultPosition, wxSize(500,500), wxMINIMIZE_BOX | wxMAXIMIZE_BOX | wxRESIZE_BORDER | wxCAPTION );
	 imagebox->Show();
     tamiltextctrl=new wxTextCtrl(this,-1,wxT(" "),wxDefaultPosition,wxDefaultSize, wxTE_MULTILINE |wxTE_LEFT |wxWANTS_CHARS , wxDefaultValidator, wxTextCtrlNameStr);
     tamiltextctrl->SetFont(wxFont(16,wxNORMAL, wxNORMAL, wxBOLD, 0, wxT("tscarial")));

     ////debug//////
	logwin = new MyFrame(this, -1,wxT("Log Window"),wxPoint(100,100),wxSize(500,300));
	logwin->Show();
	logtarget->SetActiveTarget( new wxLogTextCtrl(logwin->logtext) );
	 ///end debug/////
	SetIcon(wxIcon(sample_xpm));
}

void MyTamilFrame::CreateMyMenuBar()
{
    SetMenuBar( MyMenuBarFunc() );
}

void MyTamilFrame::CreateMyToolBar()
{
    wxToolBar *tb = CreateToolBar(/* wxTB_VERTICAL*/wxTB_HORIZONTAL|wxTB_TEXT|wxTB_3DBUTTONS );
    MyToolBarFunc( tb );

}

void MyTamilFrame::OnUsinghelp( wxCommandEvent &event )
{


}
/** function to call segment and train dialog */
void MyTamilFrame::OnSegment( wxCommandEvent &event )
{
 train=new MyTrain(this,-1,wxT("Segement"));
 train->Show();
 //wxMessageBox("Segment");
}
void MyTamilFrame::OnFont( wxCommandEvent &event )
{

	wxFontData data;
	wxFontDialog fond(this,data);
	if(fond.ShowModal()==wxID_OK)
	{
		wxFontData fdata = fond.GetFontData();
        wxFont font = fdata.GetChosenFont();
        wxColour colour = fdata.GetColour();
		tamiltextctrl->SetFont(font);
	}


}

void MyTamilFrame::OnFit( wxCommandEvent &event )
{
	zoomlevel = 1;
    freshredraw();
	imagebox->Refresh();
}
/** function to zoom out */
void MyTamilFrame::OnZoomout( wxCommandEvent &event )
{

	switch(zoomlevel)
	{
	case 3:
	zoomlevel=3	;
	break;

	case 0:
	zoomlevel=1	;
	break;

	case 1:
	zoomlevel=2	;
	break;

	case 2:
	zoomlevel=3	;
	break;
	}

	freshredraw();
	imagebox->Refresh();
}
/** function to zoom in */
void MyTamilFrame::OnZoomin( wxCommandEvent &event )
{
    switch(zoomlevel)
	{
	case 3:
	zoomlevel=2	;
	break;

	case 2:
	zoomlevel=1	;
	break;

	case 1:
	zoomlevel=0	;
	break;

	case 0:
	zoomlevel=0;
	break;
	}
	freshredraw();
	imagebox->Refresh();
}

void MyTamilFrame::OnSkew( wxCommandEvent &event )
{
	CImage Img,Imgtemp;
	CCoordinateTransform ctran;
	double skew1,skew2,skewangle;
	Img.Load("temp1.bmp");
	Imgtemp.CopyConvert(1,Img);
	wxBeginBusyCursor(wxHOURGLASS_CURSOR);

	skew1=findskew(Imgtemp);
	ctran.ScaleAndRotateAuto(Imgtemp,Imgtemp,1,1,skew1,1);
	skew2=findskew(Imgtemp);
	skewangle=(skew1+skew2);
	ctran.ScaleAndRotateAuto(Img,Imgtemp,1,1,skewangle,1);
	Imgtemp.Save("temp1.bmp");
	wxEndBusyCursor();
	wxLogMessage(wxT("%f"),skew1*180/3.14);
	freshredraw();
	imagebox->Refresh(true, NULL);
	wxMessageBox(wxT("Skew Corrected"));
}
/** function to rotate image 270 degree */
void MyTamilFrame::OnRotate270( wxCommandEvent &event )
{
    CImage Img;
    Img.Load("temp1.bmp");
    Img.Rotate90(3);
    Img.Save("temp1.bmp");
	freshredraw();
    imagebox->Refresh();

}
/** function to rotate image 180 degree */
void MyTamilFrame::OnRotate180( wxCommandEvent &event )
{

    CImage Img;
    Img.Load("temp1.bmp");
    Img.Rotate90(2);
    Img.Save("temp1.bmp");
	freshredraw();
    imagebox->Refresh();

}
/** function to rotate image 90 degree */
void MyTamilFrame::OnRotate90( wxCommandEvent &event )
{

    CImage Img;
    Img.Load("temp1.bmp");
    Img.Rotate90(1);
    Img.Save("temp1.bmp");
	freshredraw();
    imagebox->Refresh();

}
/** function to invert the colur of image */
void MyTamilFrame::OnRevimage( wxCommandEvent &event )
{
    CImage Img;
    Img.Load("temp1.bmp");
    Img.Invert();
    Img.Save("temp1.bmp");
	freshredraw();
    imagebox->Refresh();

}
/** function to clear "Salt and Pepper Noise" */
void MyTamilFrame::OnClear( wxCommandEvent &event )
{
    CImage Img,Imgdest;
    int i,j;
    int x,y;
	wxBeginBusyCursor(wxHOURGLASS_CURSOR);
	Img.Load("temp1.bmp");
    x=Img.GetWidth();
    y=Img.GetHeight();
    for(i=0;i<x;i++)
    {
    Img.SetPixelFast(i,0,1);
    Img.SetPixelFast(i,y-1,1);
    }
    for(i=0;i<y;i++)
    {
    Img.SetPixelFast(0,i,1);
    Img.SetPixelFast(x-1,i,1);
    }
    for(i=1;i<y;i++)
    {
    for(j=1;j<x;j++)
    {
     if(Img.GetPixelFast(j,i)==0)
     {
        if((Img.GetPixelFast(j-1,i-1)==1)
			&& (Img.GetPixelFast(j,i-1)==1)
			&&(Img.GetPixelFast(j+1,i-1)==1 )
			&&(Img.GetPixelFast(j-1,i)==1 )
			&&(Img.GetPixelFast(j+1,i)==1 )
			&&(Img.GetPixelFast(j-1,i+1)==1 )
			&&(Img.GetPixelFast(j,i+1)==1)
			&&(Img.GetPixelFast(j+1,i+1)==1) )
         {
         Img.SetPixelFast(j,i,1);
          }
     }

     if(Img.GetPixelFast(j,i)==1)
     {
        if((Img.GetPixelFast(j-1,i-1)==0)
			&& (Img.GetPixelFast(j,i-1)==0)
			&&(Img.GetPixelFast(j+1,i-1)==0 )
			&&(Img.GetPixelFast(j-1,i)==0 )
			&&(Img.GetPixelFast(j+1,i)==0 )
			&&(Img.GetPixelFast(j-1,i+1)==0 )
			&&(Img.GetPixelFast(j,i+1)==0)
			&&(Img.GetPixelFast(j+1,i+1)==0) )
         {
         Img.SetPixelFast(j,i,0);
          }
     }

     if((Img.GetPixelFast(j,i)==0) && (Img.GetPixelFast(j-1,i-1)==0))
     {
        if((Img.GetPixelFast(j-2,i-2)==1)
			&&(Img.GetPixelFast(j-1,i-2)==1)
			&&(Img.GetPixelFast(j,i-2)==1)
			&& (Img.GetPixelFast(j-2,i-1)==1)
			&&(Img.GetPixelFast(j-2,i)==1)
			&&(Img.GetPixelFast(j,i-1)==1)
			&&(Img.GetPixelFast(j+1,i-1)==1 )
			&&(Img.GetPixelFast(j-1,i)==1 )
			&&(Img.GetPixelFast(j+1,i)==1 )
			&&(Img.GetPixelFast(j-1,i+1)==1 )
			&&(Img.GetPixelFast(j,i+1)==1)
			&&(Img.GetPixelFast(j+1,i+1)==1) )
         {
         Img.SetPixelFast(j,i,1);
         Img.SetPixelFast(j-1,i-1,1);
          }
     }

     if((Img.GetPixelFast(j,i)==0)&& (Img.GetPixelFast(j,i-1)==0))
     {
        if((Img.GetPixelFast(j-1,i-2)==1)
			&&(Img.GetPixelFast(j,i-2)==1)
			&&(Img.GetPixelFast(j+1,i-2)==1)
			&&(Img.GetPixelFast(j-1,i-1)==1)
			&&(Img.GetPixelFast(j+1,i-1)==1 )
			&&(Img.GetPixelFast(j-1,i)==1 )
			&&(Img.GetPixelFast(j+1,i)==1 )
			&&(Img.GetPixelFast(j-1,i+1)==1 )
			&&(Img.GetPixelFast(j,i+1)==1)
			&&(Img.GetPixelFast(j+1,i+1)==1) )
         {
         Img.SetPixelFast(j,i,1);
         Img.SetPixelFast(j,i-1,1);
          }
     }

     if((Img.GetPixelFast(j,i)==0)&&(Img.GetPixelFast(j+1,i-1)==0 ))
     {
        if((Img.GetPixelFast(j,i-2)==1)
			&&(Img.GetPixelFast(j+1,i-2)==1)
			&&(Img.GetPixelFast(j+2,i-2)==1)
			&&(Img.GetPixelFast(j+2,i)==1)
			&&(Img.GetPixelFast(j-1,i-1)==1)
			&& (Img.GetPixelFast(j,i-1)==1)
			&&(Img.GetPixelFast(j-1,i)==1 )
			&&(Img.GetPixelFast(j+1,i)==1 )
			&&(Img.GetPixelFast(j-1,i+1)==1 )
			&&(Img.GetPixelFast(j,i+1)==1)
			&&(Img.GetPixelFast(j+1,i+1)==1) )
         {
         Img.SetPixelFast(j,i,1);
         Img.SetPixelFast(j+1,i-1,1);
          }
     }

     if((Img.GetPixelFast(j,i)==0)&&(Img.GetPixelFast(j-1,i)==0 ))
     {
        if((Img.GetPixelFast(j-2,i-1)==1)
			&&(Img.GetPixelFast(j-2,i)==1)
			&&(Img.GetPixelFast(j-2,i+1)==1)
			&&(Img.GetPixelFast(j-1,i-1)==1)
			&& (Img.GetPixelFast(j,i-1)==1)
			&&(Img.GetPixelFast(j+1,i-1)==1 )
			&&(Img.GetPixelFast(j+1,i)==1 )
			&&(Img.GetPixelFast(j-1,i+1)==1 )
			&&(Img.GetPixelFast(j,i+1)==1)
			&&(Img.GetPixelFast(j+1,i+1)==1) )
         {
         Img.SetPixelFast(j,i,1);
         Img.SetPixelFast(j-1,i,1);
          }
     }
     if((Img.GetPixelFast(j,i)==0)&&(Img.GetPixelFast(j+1,i)==0 ))
     {
        if((Img.GetPixelFast(j+2,i-1)==1)
			&&(Img.GetPixelFast(j+2,i)==1)
			&&(Img.GetPixelFast(j+2,i+1)==1)
			&&(Img.GetPixelFast(j-1,i-1)==1)
			&& (Img.GetPixelFast(j,i-1)==1)
			&&(Img.GetPixelFast(j+1,i-1)==1 )
			&&(Img.GetPixelFast(j-1,i)==1 )
			&&(Img.GetPixelFast(j-1,i+1)==1 )
			&&(Img.GetPixelFast(j,i+1)==1)
			&&(Img.GetPixelFast(j+1,i+1)==1) )
         {
         Img.SetPixelFast(j,i,1);
         Img.SetPixelFast(j+1,i,1);
          }
     }

     if((Img.GetPixelFast(j,i)==0)&&(Img.GetPixelFast(j-1,i+1)==0 ))
     {
        if((Img.GetPixelFast(j-2,i)==1)
			&&(Img.GetPixelFast(j-2,i+1)==1)
			&&(Img.GetPixelFast(j-2,i+2)==1)
			&&(Img.GetPixelFast(j-1,i+2)==1)
			&&(Img.GetPixelFast(j,i+2)==1)
			&&(Img.GetPixelFast(j-1,i-1)==1)
			&& (Img.GetPixelFast(j,i-1)==1)
			&&(Img.GetPixelFast(j+1,i-1)==1 )
			&&(Img.GetPixelFast(j-1,i)==1 )
			&&(Img.GetPixelFast(j+1,i)==1 )
			&&(Img.GetPixelFast(j,i+1)==1)
			&&(Img.GetPixelFast(j+1,i+1)==1) )
         {
         Img.SetPixelFast(j,i,1);
         Img.SetPixelFast(j+1,i,1);
          }
     }


     if((Img.GetPixelFast(j,i)==0)&&(Img.GetPixelFast(j,i+1)==0))
     {
        if((Img.GetPixelFast(j-1,i+2)==1)
			&&(Img.GetPixelFast(j,i+2)==1)
			&&(Img.GetPixelFast(j+1,i+2)==1)
			&&(Img.GetPixelFast(j-1,i-1)==1)
			&& (Img.GetPixelFast(j,i-1)==1)
			&&(Img.GetPixelFast(j+1,i-1)==1 )
			&&(Img.GetPixelFast(j-1,i)==1 )
			&&(Img.GetPixelFast(j+1,i)==1 )
			&&(Img.GetPixelFast(j-1,i+1)==1 )
			&&(Img.GetPixelFast(j+1,i+1)==1) )
         {
         Img.SetPixelFast(j,i,1);
         Img.SetPixelFast(j,i+1,1);
          }
     }

     if((Img.GetPixelFast(j,i)==0) &&(Img.GetPixelFast(j+1,i+1)==0))
     {
        if((Img.GetPixelFast(j+2,i)==1)
			&&(Img.GetPixelFast(j+2,i+1)==1)
			&&(Img.GetPixelFast(j-1,i-1)==1)
			&& (Img.GetPixelFast(j,i-1)==1)
			&&(Img.GetPixelFast(j+1,i-1)==1 )
			&&(Img.GetPixelFast(j-1,i)==1 )
			&&(Img.GetPixelFast(j+1,i)==1 )
			&&(Img.GetPixelFast(j-1,i+1)==1 )
			&&(Img.GetPixelFast(j,i+1)==1)
			&&(Img.GetPixelFast(j,i+2)==1)
			&&(Img.GetPixelFast(j+1,i+2)==1)
			&&(Img.GetPixelFast(j+2,i+2)==1))
         {
         Img.SetPixelFast(j,i,1);
         Img.SetPixelFast(j+1,i+1,1);
          }
     }

    }
    }
    Img.Save("temp1.bmp");
    freshredraw();
    imagebox->Refresh();

	wxEndBusyCursor();
    wxMessageBox(wxT("Noise Cleared"), wxT("Preprocessing"),wxOK,NULL, -1, -1);
}

void MyTamilFrame::OnOptions( wxCommandEvent &event )
{
	wxMessageBox(wxT("Not available in this version"));
	/*
    CImage Img,Imghist;
	Img.Load("tempgray.bmp");
	int thres=findotsu_threshold(Img);

	Imghist.Load("hist.bmp");
	double *hist;
	hist=findhistogram(Img);
	for(int i=0;i<256;i++)
	{
		for(int j=0;j<hist[i];j++)
		{
			Imghist.SetPixel(i,j,0);
		}

			//
			wxString ms;
			ms.Printf("%f",hist[i]);
			wxLogMessage(ms);
	}
	Imghist.Save("Histogram.bmp");

	wxString ms;
	ms.Printf("%d",thres);
	wxLogMessage(ms);

	Img.CopyConvertThreshold(thres,Img);
	Img.Save("tempbinary.bmp");
	*/
}

void MyTamilFrame::OnBatch( wxCommandEvent &event )
{
 wxMessageBox(wxT("Not available in this version"));
}

void MyTamilFrame::OnRead( wxCommandEvent &event )
{

	//wxProgressDialog prog(wxT("Process"), "Click cancel",100,NULL, wxPD_AUTO_HIDE | wxPD_CAN_ABORT );


	recognize();

}

void MyTamilFrame::OnSavetextas( wxCommandEvent &event )
{
	wxFileDialog fd(this,wxT("Choose a file to save text"),wxT(""),wxT("gtamil.txt"),wxT("*.txt"), wxSAVE, wxDefaultPosition);
	int fdm=fd.ShowModal();
	if(fdm==wxID_OK)
	tamiltextctrl->SaveFile(fd.GetPath());
}

void MyTamilFrame::OnSaveimageas( wxCommandEvent &event )
{
 CImage imgsave;
 wxFileDialog dialsave(this,wxT("Save image as"),wxT(""),wxT("gtamilocr.bmp"),wxT("Bitmap images(*.bmp)|*.bmp"),wxSAVE|wxOVERWRITE_PROMPT);
 dialsave.SetFilterIndex(1);
 imgsave.Load("temp2.bmp");
 if (dialsave.ShowModal() == wxID_OK)
    {
	imgsave.Save(dialsave.GetPath().mb_str());
    }
 else
   {
	 return;
   }
}

void MyTamilFrame::OnSave( wxCommandEvent &event )
{
 CImage imgsave;
 wxFileDialog dialsave(this,wxT("Save image as"),wxT(""),wxT("gtamilocr.bmp"),wxT("Bitmap images(*.bmp)|*.bmp"),wxSAVE|wxOVERWRITE_PROMPT);
 dialsave.SetFilterIndex(1);
 imgsave.Load("temp2.bmp");
 if (dialsave.ShowModal() == wxID_OK)
    {
	imgsave.Save(dialsave.GetPath().mb_str());
    }
 else
   {
	 return;
   }
}
/** funtion to open the image file*/
void MyTamilFrame::OnOpen( wxCommandEvent &event )
{
 zoomlevel=2;
 int th;
 CImage imgsrc;
 wxImage timg;
 wxBitmap *tbmp;
 //wxImage::AddHandler( new wxBMPHandler );
 wxInitAllImageHandlers();
 wxFileDialog dlg(this,wxT("Open a file"),wxT(" "),wxT(""),wxT("BMP files (*.bmp)|*.bmp|PGM files (*.pgm)|*.pgm"),0,wxPoint(300,300));
 dlg.SetFilterIndex(2);
  if(dlg.ShowModal()==wxID_OK)
 {
 filename=dlg.GetPath();
 timg.LoadFile(filename,wxBITMAP_TYPE_ANY,-1);


 imgsrc.Load(filename.mb_str());
 }
 else
 {
 return;
 }
 if((imgsrc.GetBits())==8)
 {
 th=findotsu_threshold(imgsrc);
 imgsrc.CopyConvertThreshold(th,imgsrc);
 }
 imgsrc.Save("temp1.bmp");
 imgsrc.Save("temp2.bmp");
 imgsrc.Save("tempslash.bmp");

 timg.LoadFile(wxT("temp1.bmp"), wxBITMAP_TYPE_ANY,-1);
 Refresh(true,NULL);
 bitt=wxBitmap(timg);
 freshredraw();
 imagebox->Refresh();
}
/** funtion to display the about dialog box*/
void MyTamilFrame::OnAbout( wxCommandEvent &event )
{
    gtamilAbout about(this,-1,wxT("About GNU Tamil OCR"));
    about.CentreOnParent(wxBOTH);
    about.ShowModal();
}


/** funtion to display feture selection dialog*/
void MyTamilFrame::OnFeature( wxCommandEvent &event )
{
    MyFeatureDialog fselect(this,-1,wxT("Feature"));
    fselect.CentreOnParent(wxBOTH);
    fselect.ShowModal();
}


/** funtion to quit the application*/
void MyTamilFrame::OnQuit( wxCommandEvent &event )
{
   Close(TRUE);
}


void MyTamilFrame::OnCloseWindow( wxCloseEvent &event )
{
    // if ! saved changes -> return

    Destroy();
}

void MyTamilFrame::OnSize( wxSizeEvent &event )
{
    event.Skip( TRUE );
}

void MyTamilFrame::OnPaint(wxPaintEvent& WXUNUSED(event))
{

}
/** funtion to repaint the window,*/
void MyTamilFrame::freshredraw()
{

 wxImage timg,tview;
 wxBitmap bimap;
 CImage temp;
 CCoordinateTransform tran;
 temp.Load("temp1.bmp");
switch(zoomlevel)
  {
 case 0:
	  tran.ScaleAuto(temp, temp, 1, 1, 1);
	  break;
 case 1:
     tran.ScaleAuto(temp, temp, .5, .5, 1);
	 break;
 case 2:
	  tran.ScaleAuto(temp, temp, .25, .25, 1);
	  break;
 case 3:
	  tran.ScaleAuto(temp, temp, .125, .125, 1);
	  break;

 }
 temp.Save("tempview.bmp");
 tview.LoadFile(wxT("tempview.bmp"), wxBITMAP_TYPE_ANY,-1);
 bitt=wxBitmap(tview);


}
void MyTamilFrame::createtemp()
{
//CImage temp1;
//temp1.Load(filename);

}

/** funtion to compute the skew angle of the scanned document*/

void MyTamilFrame::recognize()
{
	CImage Img,Imgline,Imglinetemp,Imgdest,Imgblob,Imgtemp,Imgcol,Imgword,Imgwordtemp,Img8bit;
    int x,y,x1; ////changed from UINT32
	double noiselevel;
	int nosen,nowor;
	CMorphology morph;
	CMaskOperation maop;
	CCoordinateTransform ctran;
	wxString tword;
    int linecount=1;
    int wordcount=1,v;
	int linexy[100];
	int wordxy[20];
	CImage ImgMask(2,3,2);
	wxChar recogccode[3];
	int minindex;
	double temp1, recogtemp=pow(2,100)-1;
	/*
	wxString mse;
	mse.Printf("value( %f )of ",recogtemp);
	wxLogMessage(mse);
	*/
	///
	CFeatures ftl;
	CMorphology morp;

	CPixelGroups pgl,pgss;
	int ikcount;
	CSegmentate segl;
	int *word,*sentence;
	CPixelGroup pg,pge;
	double dist;
  	int i,j,k,n,m; //iterators
	int rowsum,colsum;
	double *colsumvector;
    double *rowsumvector;
	db *fdbarray ;
	int segarr[100][100];
	Img.Load("temp1.bmp");
    Img8bit.CopyConvert(8,Img);
    Img8bit.Save("temp18bit.bmp");
	Img.Invert();
	x=Img.GetWidth();
	y=Img.GetHeight();
	struct word_order{
		unsigned int x1;
		unsigned int y1;
		unsigned int x2;
		unsigned int y2;
		unsigned int position;
	}tempsort1;
	struct sol_info {
		unsigned int x1;
		unsigned int y1;
		unsigned int x2;
		unsigned int y2;
		wxChar recogcode[3];
	}tempsolinfo;
		//// db init

	if( (filr.Open("temp.txt","rb")) !=1)
	{
	wxMessageBox("temp.txt Not found");
	Close(TRUE);

	}
    for(k=0;(filr.Eof()!=1);k++)
	{
    filr.Read((&fdb),sizeof(fdb));
	}

	wxString mm;
	mm.Printf("%d",k);
	wxLogMessage(mm);
	fdbarray = new db[k+1];
	int totalrecord=k;
	filr.Close();
	filr.Open("temp.txt",/*wxFFile::read*/"rb");
	 for(k=0;(filr.Eof()!=1);k++)
	{
	filr.Read(&(/*fdb*/fdbarray[k]),sizeof(/*fdb*/fdbarray[k]));
	wxLogMessage(fdbarray[k].ccode);
	//=fdb;
	}
	 filr.Close();
		//// db init end

	rowsumvector=new double[y];
	for(i=0;i<y;i++)    // horizontal projection
	{
	CImage::ConstRowIterator1bp itrow=Img.ConstRow1bp(i);
	rowsum=0;
	while(itrow!=itrow.End())
	{
	 rowsum=rowsum+ (*itrow++) ;
	}
	 rowsumvector[i]=rowsum;
	}  // hproj end

     linexy[0]=0;
	 noiselevel=2;
	 for(i=0;i<y;i++)  //inter sentence space calculation
       {


	  if((rowsumvector[i]<noiselevel) && (rowsumvector[i+1]>=noiselevel))
	  {
		  linexy[linecount]=i;
		  linecount++;
	  }
	  if((rowsumvector[i]>=noiselevel) && (rowsumvector[i+1]<noiselevel))
      {
	  linexy[linecount]=i+1;
	  linecount++;
      }
      }
      linexy[linecount]=y-1;




  	  sentence=new int[linecount];
  	  j=0;
      for(i=0;i<=linecount;i=i+2)
      {
          sentence[j]=linexy[i]+(linexy[i+1]-linexy[i])/2;
          j++;
      }
      nosen=j-1;

       //adjust the border to 0 and y
       sentence[0]=0;
       sentence[nosen]=y-1;



      for(m=0;m<nosen;m++)
      {     wordcount=1;
           Img.CopyConvert(8,Img);
           Imglinetemp.CopySubImage(Img,0,sentence[m],x-1,sentence[m+1]);
           Imglinetemp.CopyConvert(1,Imglinetemp);
		   Imglinetemp.SetOrigo(0,0);

		   Imglinetemp.SetBorderSize(3);
		   Imglinetemp.SetBorderColor(0);

             for(i=0;i<5;i++)
         	{
         	 Imglinetemp.SetBorderSize(3);
		     Imglinetemp.SetBorderColor(0);
		     morph.DilateFast(Imglinetemp,3,0,3);
            }
           for(i=0;i<5;i++)
         	{
         	 Imglinetemp.SetBorderSize(3);
		     Imglinetemp.SetBorderColor(0);
		     morph.DilateFast(Imglinetemp,3,1,3);
            }

           for(i=0;i<0;i++)
         	{
            morph.ErodeFast(Imglinetemp,3,3,3);
            }
		   Imglinetemp.Save("median.bmp");
		   //wxMessageBox(" "," ");
          x1=Imglinetemp.GetWidth();

     	  colsumvector=new double[x1];
	      for(i=0;i<x1;i++)    // vertical projection
	      {
	       CImage::ConstColumnIterator1bp itcol=Imglinetemp.ConstColumn1bp(i);
	       colsum=0;
	      while(itcol!=itcol.End())
	        {
	        colsum=colsum+ (*itcol++) ;
	        }
	        colsumvector[i]=colsum;
 	       }  // vproj end

           wordxy[0]=0;
	       noiselevel=1;

	        for(i=0;i<x1;i++)  //inter sentence space calculation
            {
	       if((colsumvector[i]<noiselevel) && (colsumvector[i+1]>=noiselevel))
	        {
		     wordxy[wordcount]=i;
		     wordcount++;
	        }
	        if((colsumvector[i]>=noiselevel) && (colsumvector[i+1]<noiselevel))
            {
	         wordxy[wordcount]=i+1;
	         wordcount++;
            }
             }
       wordxy[wordcount]=x1-1;

       word=new int[wordcount];
  	  j=0;
      for(i=0;i<wordcount;i=i+2)
      {
          word[j]=wordxy[i]+(wordxy[i+1]-wordxy[i])/2;
          j++;
      }
      nowor=j-1;

       //adjust the border to 0 and x
       word[0]=0;
       word[j-1]=x1-1;



     for(i=0;i<=nowor;i++)
     {
         segarr[m][i]=word[i];
     }
     segarr[m][0]=nowor;

     delete word;
     delete colsumvector;
    Imglinetemp.Empty();
    }    ////

	Imgdest.Load("temp18bit.bmp");

    for(m=0;m<nosen;m++)
    {
            for(n=0;n<segarr[m][0];n++)
                {

	  Imgword.CopySubImage(Imgdest,segarr[m][n],sentence[m],segarr[m][n+1],sentence[m+1]);
      Imgword.CopyConvert(1,Imgword);
	  Imgword.SetOrigo(0,0);
	  /////////new----from train
	  segl.DeriveBlobs(Imgword,pgss,LOWCOLOR,128,EIGHTCONNECTED,1);
	  word_order *wordorder;
	  wordorder= new word_order[pgss.GetTotalGroups()];
	   for(i=0;i<pgss.GetTotalGroups();i++)
	   {
		   wordorder[i].x1=pgss[i].GetLeft().GetX();
		   wordorder[i].y1=pgss[i].GetTop().GetY();
		   wordorder[i].x2=pgss[i].GetRight().GetX();
		   wordorder[i].y2=pgss[i].GetBottom().GetY();
		   wordorder[i].position=i;


	   }
	   int last,exchs;
	   last=pgss.GetTotalGroups()-1;
	   for(i=0;i<pgss.GetTotalGroups()-1;i++)
	   {  exchs=0;
		   for(j=0;j<last;j++)
		   {
			   if((wordorder[j].x1) > (wordorder[j+1].x1) )
			    {

				   tempsort1.x1=wordorder[j].x1;
				   tempsort1.y1=wordorder[j].y1;
				   tempsort1.x2=wordorder[j].x2;
				   tempsort1.y2=wordorder[j].y2;
				   tempsort1.position=wordorder[j].position;

				   wordorder[j].x1=wordorder[j+1].x1;
				   wordorder[j].x2=wordorder[j+1].x2;
				   wordorder[j].y1=wordorder[j+1].y1;
				   wordorder[j].y2=wordorder[j+1].y2;
				   wordorder[j].position=wordorder[j+1].position;

				   wordorder[j+1].x1=tempsort1.x1;
				   wordorder[j+1].x2=tempsort1.x2;
				   wordorder[j+1].y1=tempsort1.y1;
				   wordorder[j+1].y2=tempsort1.y2;
				   wordorder[j+1].position=tempsort1.position;
				   exchs=exchs+1;

			    }
		   }
		   if(exchs!=0)
		   {
			   last=last-1;
		   }
	   }
	   sol_info *soluru;
	   soluru=new sol_info[pgss.GetTotalGroups()];
	  for(v=0;v<pgss.GetTotalGroups();v++)
	      {	 pgss[wordorder[v].position].CopyToImage(1,0,1,Imgword);
	         pgss[wordorder[v].position].CopyToImage(1,0,1,Imgwordtemp);

			 soluru[v].x1=wordorder[v].x1;
			 soluru[v].y1=wordorder[v].y1;
			 soluru[v].x2=wordorder[v].x2;
			 soluru[v].y2=wordorder[v].y2;

			 /*
			  wxString mss;
			  mss.Printf(".%d.",pgss.GetTotalGroups());
			  wxLogMessage(mss);
	        */

	  //pgss[v].CopyToImage(1,0,1,Imgword);
	      Imgword.SetOrigo(0,0);
	  //if( (Imgword.GetWidth()*Imgword.GetHeight()) >1)
	  	  testdb.hiwi= 1000.0*((double)pgss[wordorder[v].position].GetWidth()/(double)pgss[wordorder[v].position].GetHeight());
	/*
			wxString ms;
			ms.Printf("h=%d w=%d HIWI %f HIWI",pgss[v].GetWidth(),pgss[v].GetHeight(),testdb.hiwi);
			wxLogMessage(ms);
		  */
	Imgwordtemp.SetOrigo(0,0);
	morp.Thinning(Imgwordtemp);
	 pge.Empty();
	 Imgwordtemp.SetOrigo(0,0);
	 for(i=0;i<Imgwordtemp.GetHeight();i++)
		 {
			 for(j=0;j<Imgwordtemp.GetWidth();j++)
			 {
				 if(Imgwordtemp.GetPixel(j,i)==0)
					 pge.AddPosition(j,i);
			 }
		 }


	//if((imgblobtemp.GetWidth()*imgblobtemp.GetHeight() )>5)
	if( (pge.GetWidth()*pge.GetHeight())>100 )
	{
	ctran.ScaleAuto(Imgword,Imgword,(double)64.1/(double)pgss[wordorder[v].position].GetWidth(),(double)64.1/(double)pgss[wordorder[v].position].GetHeight(),1);
	Imgword.SetOrigo(0,0);


	morp.Thinning(Imgword);

	Imgword.Invert();
	Imgword.Save("word.bmp");
	//pgss[v].CopyToImage(1,0,1,Imgword);
	Imgword.SetOrigo(0,0);
     k=0;
	 pg.Empty();

     for(i=0;i<64;i=i+16)
	 {
		 for(j=0;j<64;j=j+16)
		 {
		      for(y=i;y<(i+16);y++)
	           {
	          for(x=j;x<(j+16);x++)
		       {
			   if(Imgword.GetPixel(x,y)==1)
			   pg.AddPosition(x,y);
		       }
               }
			  if(pg.GetTotalPositions()==0)
			  {
				testdb.moin[k][0]=0;
            	testdb.moin[k][1]=0;
                testdb.moin[k][2]=0;
             	testdb.moin[k][3]=0;
			  }
			  else
			  {
			  pg.CopyToImage(1,0,1,Imgline);
			  Imgline.Save("wordx.bmp");
			    ftl.DeriveMomentsBinary(pg,3);
                ftl.DeriveCentralMoments();
			   	testdb.moin[k][0]=.001*(ftl.m_CentrMom.m20+ftl.m_CentrMom.m02);
            	testdb.moin[k][1]=.001*(sqrt((pow((ftl.m_CentrMom.m20+ftl.m_CentrMom.m02),2)+4*pow(ftl.m_CentrMom.m11,2))) );
                testdb.moin[k][2]=.001*(sqrt(pow((ftl.m_CentrMom.m30) - (3*ftl.m_CentrMom.m12),2) + pow((3*(ftl.m_CentrMom.m21))-(ftl.m_CentrMom.m03),2)));
             	testdb.moin[k][3]=.001*(((ftl.m_CentrMom.m30)+(ftl.m_CentrMom.m03)));
			  }
				k++;
		 }
	 }
	}




	if((pge.GetWidth()*pge.GetHeight())<=100 )
	{
		if( (pge.GetWidth()*pge.GetHeight())==0)
				{
					pge.AddPosition(0,0);
				}

		        ftl.DeriveMomentsBinary(pge,3);
                ftl.DeriveCentralMoments();
				for(k=0;k<16;k++)
				{
			   	testdb.moin[k][0]=1*(ftl.m_CentrMom.m20+ftl.m_CentrMom.m02);
            	testdb.moin[k][1]=1*(sqrt((pow((ftl.m_CentrMom.m20+ftl.m_CentrMom.m02),2)+4*pow(ftl.m_CentrMom.m11,2))) );
                testdb.moin[k][2]=1*(sqrt(pow((ftl.m_CentrMom.m30) - (3*ftl.m_CentrMom.m12),2) + pow((3*(ftl.m_CentrMom.m21))-(ftl.m_CentrMom.m03),2)));
             	testdb.moin[k][3]=1*(((ftl.m_CentrMom.m30)+(ftl.m_CentrMom.m03)));
				}

	}

	 Imgword.Invert();
	// pg.Empty();
	 /*
  Imgword.SetOrigo(0,0);
	 for(i=0;i<64;i++)
	 {  for(j=0;i<64;j++)
	  {
		// if(Imgword.GetPixelFast(j,i)==0)
		 {
		 // pg.AddPosition(j,i);
		 }
	  }
	 }
	 testdb.hiwi=(pg.GetWidth()/pg.GetHeight());
     ftl.DeriveMomentsBinary(pg,3);
	 ftl.DeriveCentralMoments();
	 ftl.DeriveHuFromCentralMom();
			 for(i=0;i<1;i++) {
		      testdb.hu[i]=(ftl.m_Hu[i]);
			 }
	*/
	 pg.Empty();
	recogtemp=pow(2,80)-1;
	temp1=0.0;

	recogccode[0]=wxChar(' ');
	recogccode[1]=wxChar(' ');
	recogccode[2]=wxChar(' ');

	dist=0;


	for(k=0;k<=totalrecord/*(filr.Eof()!=1)*/;k++)
	{

	/*filr.Read(&(fdb),sizeof(fdb));*/
	fdb=fdbarray[k];
	dist=0;
	for(i=0;i<16;i++)
	{
 	dist=dist + pow((fdbarray[k].moin[i][0]-testdb.moin[i][0]),2)+
	pow((fdbarray[k].moin[i][1]-testdb.moin[i][1]),2)+
	pow((fdbarray[k].moin[i][2]-testdb.moin[i][2]),2) +
	pow((fdbarray[k].moin[i][3]-testdb.moin[i][3]),2);
	/*
			wxString ms;
			ms.Printf("f1=%f f2=%f f3=%f f4=%f",testdb.moin[i][0],testdb.moin[i][1],testdb.moin[i][2],testdb.moin[i][3]);
			wxLogMessage(ms);
	*/
	//+pow((dbarr[segmentslide->GetValue()].moin[i][4]-cdb.moin[i][4]),2) ;
    }
	dist=dist+pow(fdbarray[k].hiwi-testdb.hiwi,2);
/*	for(i=0;i<1;i++)
	{
	dist=dist+pow((fdb.hu[i]-testdb.hu[i]),2);
	}*/
	/*
	dist=sqrt(dist);
	wxString ms;
	ms.Printf("%f %s",dist,fdb.ccode);
	wxLogMessage(ms);*/
	if(dist<=recogtemp)
	{
	   temp1=recogtemp;
	   recogtemp=dist;
       dist=temp1;
       recogccode[0]=fdb.ccode[0];
       recogccode[1]=fdb.ccode[1];
       recogccode[2]=fdb.ccode[2];
	}

    }
	filr.Close();
	soluru[v].recogcode[0]=recogccode[0];
	soluru[v].recogcode[1]=recogccode[1];
    soluru[v].recogcode[2]=recogccode[2];
	  //tword.Append(soluru[v].recogcode);


    //////test ik im ir and ee uu //

			}///v

	for(v=0;v<pgss.GetTotalGroups();v++)
	 {
		//wxString ms;
	   //ms.Printf("%d %d %d %d %s \n",soluru[v].x1,soluru[v].y1,soluru[v].x2,soluru[v].y2,soluru[v].recogcode);
	   //wxLogMessage(ms);

		if(v!=(pgss.GetTotalGroups()-1))
		{
		if( (soluru[v].recogcode[0]!='.') && (soluru[v+1].recogcode[0]=='.') &&
		 ((soluru[v+1].x1)> (soluru[v].x1))&& ( (soluru[v+1].x1)< (soluru[v].x2) )&&
		 (soluru[v].recogcode[1]=='\0'))
		{

	    wxMessageBox("ok");
		wxChar tc=soluru[v].recogcode[0];
//
//		if(tc=='¸')
//		tword.Append("ì");//ik
//		if(tc=='¹')
//		tword.Append("í");//ink
//		if(tc=='º')//º
//		tword.Append("î");//ich î
//		if(tc=='»')
//		tword.Append("ï");//inch
//		if(tc=='¼')
//		tword.Append("ð");//it
//
//		if(tc=='½')
//		tword.Append("ñ");//in
//		if(tc=='¾')
//		tword.Append("ò");//ith
//		if(tc=='¿')
//		tword.Append("ó");//inth
//		if(tc=='À')
//		tword.Append("ô");//ipu
//		if(tc=='Á')
//		tword.Append("õ");//im
//
//		if(tc=='Â')
//		tword.Append("ö");//ie
//		if(tc=='Ã')
//		tword.Append("÷");//ir
//		if(tc=='¡')
//		tword.Append("÷");//ir
//		if(tc=='Ä')
//		tword.Append("ø");//il
//		if(tc=='Å')
//		tword.Append("ù");//iv
//
//		if(tc=='Æ')
//		tword.Append("ú");//ill
//		if(tc=='Ç')
//		tword.Append("û");//ilal
//		if(tc=='È')
//		tword.Append("ü");//irr
//		if(tc=='É')
//		tword.Append("ý");//in
//		//
//		if(tc=='')
//		tword.Append("");//ics
//		if(tc=='')
//		tword.Append("");//iss
//		if(tc=='')
//		tword.Append("");//ij
//		if(tc=='')
//		tword.Append("");//ics
//        v=v+1;



		}
		else
		{
			tword.Append(soluru[v].recogcode);
		}

	 }

	if( (v==(pgss.GetTotalGroups()-1)) && (soluru[v].recogcode[0]!='.') )
			tword.Append(soluru[v].recogcode);



	}


	 tamiltextctrl->AppendText(tword);
	 delete wordorder;
			/////////new----from train end
	  tword.Empty();
	tamiltextctrl->AppendText(" ");
	wxTheApp->Yield();
                  }

     tamiltextctrl->AppendText("\n");

   }
	delete rowsumvector;

}


//------------------------------------------------------------------------------
// MyTamilApp
//------------------------------------------------------------------------------

IMPLEMENT_APP(MyTamilApp)

MyTamilApp::MyTamilApp()
{
}

bool MyTamilApp::OnInit()
{
    wxBitmap bitmap;
    if (1)
    {
      wxSplashScreen* splash = new wxSplashScreen(wxBitmap(tamilsplash),
                                                  wxSPLASH_CENTRE_ON_SCREEN|wxSPLASH_TIMEOUT,
                                                  8000, NULL, -1, wxDefaultPosition, wxDefaultSize,
                                                  wxSIMPLE_BORDER|wxSTAY_ON_TOP);

    }



    MyTamilFrame *frame = new MyTamilFrame( NULL, -1, wxT("gTamilOCR"), wxPoint(20,20), wxSize(-1,-1),wxDEFAULT_FRAME_STYLE|wxMAXIMIZE );
	frame->Show( TRUE );

	if(frame)
	{
	    return TRUE;
	}


}

int MyTamilApp::OnExit()
{
    return 0;
}

