/* gtamilocr_menutool.cpp. This file is part of GNU Tamil OCR
 *
 * GNU Tamil OCR :  <http://gtamilocr.sourceforge.net>
 * Free, Cross-Platform, Optical Character Recognition for Tamil
 *
 * Copyright (C) 2004-2007  Visweswara R, <visweswara@users.sourceforge.net>.
 * All Rights Reserved. DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR
 * THIS FILE HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License version 3 for more details(a copy is included
 * in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "gtamilocr_menutool.h"

wxSizer *Image( wxWindow *parent, bool call_fit, bool set_sizer )
{
    wxBoxSizer *item0 = new wxBoxSizer( wxVERTICAL );

    if (set_sizer)
    {
        parent->SetSizer( item0 );
        if (call_fit)
            item0->SetSizeHints( parent );
    }

    return item0;
}



wxMenuBar *MyMenuBarFunc()
{
    wxMenuBar *item0 = new wxMenuBar;

    wxMenu* item1 = new wxMenu;
    item1->Append( ID_OPEN, wxT("&Open Image"), wxT("open image file from folder") );
    item1->AppendSeparator();
    item1->Append( ID_SAVE_IMAGE, wxT("Save Image"), wxT("Save imge to file") );
    item1->Append( ID_SAVEIMAGEAS, wxT("Save Image As"), wxT("Save Image as ") );
    item1->Append( ID_SAVETEXTAS, wxT("Save Text As"), wxT("Save Text to File") );
    item1->AppendSeparator();
    item1->Append( ID_QUIT, wxT("Quit"), wxT("Exit from file") );
    item0->Append( item1, wxT("&File") );

    wxMenu* item2 = new wxMenu;
    item2->Append( ID_CLEAR, wxT("Clear Noise"), wxT("Remove Noise from Image") );
    item2->AppendSeparator();
    item2->Append( ID_REVIMAGE, wxT("Reverse Image"), wxT("Invert the Image") );

    wxMenu* item3 = new wxMenu;
    item3->Append( ID_90, wxT("Rotate90"), wxT("Rotate 90 degree") );
    item3->Append( ID_180, wxT("Rotate180"), wxT("Rotate 180 Degree") );
    item3->Append( ID_270, wxT("Rotate270"), wxT("Rotate 270 Degree"));
    item2->Append( ID_ROTATE, wxT("Rotate"), item3 );

    item2->AppendSeparator();
    item2->Append( ID_SKEW, wxT("Skew Adjust"), wxT("Adjust the Skew Values") );
    item0->Append( item2, wxT("&Edit") );

    wxMenu* item4 = new wxMenu;
    item4->Append( ID_READ, wxT("Read"), wxT("Recognize Image") );
    item4->Append( ID_BATCH, wxT("Batch Process"), wxT("Recognize images in batch mode") );
    item4->Append( ID_OPTIONS, wxT("Options"), wxT("") );
    item0->Append( item4, wxT("&Recognize") );

    wxMenu* item5 = new wxMenu;
    item5->Append( ID_FONTS, wxT("Fonts"), wxT("Select set of Features to be used") );
    item0->Append( item5, wxT("&Options") );

    wxMenu* item6 = new wxMenu;
    item6->Append( ID_ZOOMIN, wxT("Zoom In"), wxT("Zoom In") );
    item6->Append( ID_ZOOMOUT, wxT("Zoom Out"), wxT("") );
    item6->AppendSeparator();
    item6->Append( ID_FIT, wxT("Fit Window"), wxT("Fit image in window") );
    item0->Append( item6, wxT("&View") );

    wxMenu* item7 = new wxMenu;
    item7->Append( ID_SEGMENT, wxT("Segment and Assign"), wxT("Segment Image And Assign Symbols to Image Segment") );
    item0->Append( item7, wxT("&Train") );

    wxMenu* item8 = new wxMenu;
    item8->Append( ID_ABOUT, wxT("About gtamilocr"), wxT("About GNU Tamil OCR") );
    item8->Append( ID_USING, wxT("Using gtamilocr"), wxT("Using GNU Tamil OCR") );
    item0->Append( item8, wxT("&Help") );

    return item0;
}

// Implement toolbar functions

void MyToolBarFunc( wxToolBar *parent )
{
    parent->SetMargins( 10, 10 );
    parent->SetToolBitmapSize(wxSize(24,24));
	parent->AddTool( ID_TOOLOPEN, wxT("Open"), wxBitmap(openf), wxNullBitmap, wxITEM_NORMAL, wxT("Open image"), wxT("Open image") );
    parent->AddSeparator();
    parent->AddTool( ID_TOOLSAVE, wxT("Save"),wxBitmap(save), wxNullBitmap, wxITEM_NORMAL, wxT("Save image"), wxT("Save image") );
    parent->AddTool( ID_TOOLSAVEAS, wxT("Save as"), wxBitmap(saveas), wxNullBitmap, wxITEM_NORMAL, wxT("Save image as"), wxT("Save image as") );
    parent->AddSeparator();
    parent->AddTool( ID_TOOLREAD, wxT("Read"), wxBitmap(read_xpm), wxNullBitmap, wxITEM_NORMAL, wxT("Read "), wxT("Read") );
	parent->AddSeparator();
	parent->AddTool( ID_TOOLZOOMIN, wxT("Zoom in"), wxBitmap(zoomin), wxNullBitmap, wxITEM_NORMAL, wxT("Zoom in"), wxT("Zoom in") );
    parent->AddTool( ID_TOOLZOOMOUT, wxT("Zoom out"), wxBitmap(zoomout), wxNullBitmap, wxITEM_NORMAL, wxT("Zoom out"), wxT("Zoom out") );
    parent->AddSeparator();
    parent->AddTool( ID_TOOLSKEW, wxT("Skew"), wxBitmap(skewcor), wxNullBitmap, wxITEM_NORMAL, wxT("Skew"), wxT("Skew") );
    parent->Realize();
}
