/* imagebox.cpp. This file is part of GNU Tamil OCR
 *
 * GNU Tamil OCR :  <http://gtamilocr.sourceforge.net>
 * Free, Cross-Platform, Optical Character Recognition for Tamil
 *
 * Copyright (C) 2004-2007  Visweswara R, <visweswara@users.sourceforge.net>.
 * All Rights Reserved. DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR
 * THIS FILE HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License version 3 for more details(a copy is included
 * in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "imagebox.h"
#include "openf.xpm"
#include "save.xpm"
#include "saveas.xpm"
#include "zoomin.xpm"
#include "zoomout.xpm"
#include "skewcor.xpm"
#include "read.xpm"
#include "scan.xpm"

extern wxBitmap bitt;

BEGIN_EVENT_TABLE(MyScrollPanel,wxScrolledWindow)
    EVT_PAINT( MyScrollPanel::OnPaint )
END_EVENT_TABLE()

MyScrollPanel::MyScrollPanel(wxWindow* parent, int id, const wxPoint& pos, const wxSize& size, long style):
    wxScrolledWindow(parent, id, pos, wxSize(500,500), wxTAB_TRAVERSAL)
{
    set_properties();
    do_layout();
}
void MyScrollPanel::set_properties()
{
  	SetScrollbars(5, 5,1000, 1000, 0,0,false);
    SetScrollRate(1, 1);
}
void MyScrollPanel::do_layout()
{

}
void MyScrollPanel::OnPaint( wxPaintEvent &event )
{
	wxPaintDC dc(this);
	PrepareDC(dc);
	dc.BeginDrawing();
    dc.DrawBitmap(bitt,0,0,1);
	dc.EndDrawing();
}

BEGIN_EVENT_TABLE(MyImageBox,wxFrame)
    EVT_PAINT( MyImageBox::OnPaint )
END_EVENT_TABLE()

MyImageBox::MyImageBox(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, wxMINIMIZE_BOX | wxMAXIMIZE_BOX | wxRESIZE_BORDER | wxCAPTION )
{
    imagepanel = new MyScrollPanel(this, -1);
	/*imagetool = new wxToolBar(this,-1,wxDefaultPosition,wxDefaultSize,wxTB_VERTICAL,_T("sample"));
	imagetool->SetMargins( 10, 10 );
    imagetool->SetToolBitmapSize(wxSize(24,24));
	imagetool->AddTool( 1000, wxT("Open"), wxBitmap(openf), wxNullBitmap, wxITEM_NORMAL, wxT("Open image"), wxT("Open image") );
    imagetool->AddSeparator();
    imagetool->AddTool( 1001, wxT("Save"),wxBitmap(save), wxNullBitmap, wxITEM_NORMAL, wxT("Save image"), wxT("Save image") );
    imagetool->AddTool( 1002, wxT("Save as"), wxBitmap(saveas), wxNullBitmap, wxITEM_NORMAL, wxT("Save image as"), wxT("Save image as") );
    imagetool->AddSeparator();
    imagetool->AddTool( 1003, wxT("Read"), wxBitmap(read_xpm), wxNullBitmap, wxITEM_NORMAL, wxT("Read "), wxT("Read") );
	imagetool->AddSeparator();
	imagetool->Realize();
	SetToolBar(imagetool);
	*/
	set_properties();
    do_layout();
}


void MyImageBox::set_properties()
{
	SetTitle(wxT("Image"));
}


void MyImageBox::do_layout()
{

    wxBoxSizer* sizer_2 = new wxBoxSizer(wxVERTICAL);
    sizer_2->Add(imagepanel, 1, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_2);
    sizer_2->Fit(this);
    sizer_2->SetSizeHints(this);
    Layout();

}

void MyImageBox::OnPaint( wxPaintEvent &event )
{
	wxPaintDC dc(this);
	imagepanel->Refresh(true,NULL);
}
