/* imagebox.h. This file is part of GNU Tamil OCR
 *
 * GNU Tamil OCR :  <http://gtamilocr.sourceforge.net>
 * Free, Cross-Platform, Optical Character Recognition for Tamil
 *
 * Copyright (C) 2004-2007  Visweswara R, <visweswara@users.sourceforge.net>.
 * All Rights Reserved. DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR
 * THIS FILE HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License version 3 for more details(a copy is included
 * in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU General Public License Version 3
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <wx/wx.h>
#include <wx/image.h>


class MyScrollPanel: public wxScrolledWindow {
public:

    MyScrollPanel(wxWindow* parent, int id, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=wxHSCROLL | wxVSCROLL);

private:

    void set_properties();
    void do_layout();
	void OnPaint( wxPaintEvent &event );

protected:

	DECLARE_EVENT_TABLE()
};


class MyImageBox: public wxFrame {
public:

    MyImageBox(wxWindow* parent, int id, const wxString& title, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style= wxMAXIMIZE_BOX |  wxCAPTION );

private:

    void set_properties();
    void do_layout();
	void OnPaint( wxPaintEvent &event );


protected:
    wxToolBar *imagetool;
    MyScrollPanel* imagepanel;
	DECLARE_EVENT_TABLE()

};


