/* mytraingridframe.cpp. This file is part of GNU Tamil OCR
 *
 * GNU Tamil OCR :  <http://gtamilocr.sourceforge.net>
 * Free, Cross-Platform, Optical Character Recognition for Tamil
 *
 * Copyright (C) 2004-2007  Visweswara R, <visweswara@users.sourceforge.net>.
 * All Rights Reserved. DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR
 * THIS FILE HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License version 3 for more details(a copy is included
 * in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "mytraingridframe.h"
#include <wx/grid.h>
using namespace ipl;
extern wxBitmap bitt;
BEGIN_EVENT_TABLE(MyTrainGridFrame,wxFrame)
EVT_BUTTON(ID_SAVEA,MyTrainGridFrame::onsave)
EVT_BUTTON(ID_SEGMENTS,MyTrainGridFrame::onsegment)
EVT_BUTTON(ID_ADD,MyTrainGridFrame::onadd )
END_EVENT_TABLE()

MyTrainGridFrame::MyTrainGridFrame(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, wxSize(500,500), wxDEFAULT_FRAME_STYLE|wxMAXIMIZE)
{
    // begin wxGlade: MyTrainGridFrame::MyTrainGridFrame
    Segment = new wxButton(this, ID_SEGMENTS, wxT("Segment"));
    button_2 = new wxButton(this, ID_SAVEA, wxT("Save"));
    button_3 = new wxButton(this, ID_ADD, wxT("Add"));
    grid_1 = new wxGrid(this, -1);

    set_properties();
    do_layout();
    // end wxGlade
}


void MyTrainGridFrame::set_properties()
{
    // begin wxGlade: MyTrainGridFrame::set_properties
    SetTitle(wxT("Segment and Train the page"));
    grid_1->CreateGrid(1, 1);
    grid_1->SetColLabelValue(0, wxT(""));
    // end wxGlade
}


void MyTrainGridFrame::do_layout()
{
    // begin wxGlade: MyTrainGridFrame::do_layout
    wxBoxSizer* sizer_1 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_2 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_3 = new wxBoxSizer(wxHORIZONTAL);
    sizer_3->Add(100, 0, 0, 0, 0);
    sizer_3->Add(Segment, 0, 0, 0);
    sizer_3->Add(100, 0, 0, 0, 0);
    sizer_3->Add(button_2, 0, 0, 0);
    sizer_3->Add(100, 0, 0, 0, 0);
    sizer_3->Add(button_3, 0, 0, 0);
    sizer_3->Add(100, 0, 0, 0, 0);
    sizer_2->Add(sizer_3, 0, 0, 0);
    sizer_2->Add(grid_1, 1, wxEXPAND, 0);
    sizer_1->Add(sizer_2, 1, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_1);
    sizer_1->Fit(this);
    sizer_1->SetSizeHints(this);
    Layout();
    // end wxGlade
}

void MyTrainGridFrame::onsave(wxCommandEvent &event)
{

}

void MyTrainGridFrame::onsegment(wxCommandEvent &event)
{
	grid_1->AppendCols(5,TRUE);

}

void MyTrainGridFrame::onadd(wxCommandEvent &event)
{
	CImage imgseg,imgblob;
	wxBitmap *gridbitt;
	CSegmentate segl;
	int noofglymp;
	CPixelGroups pgs;
	imgseg.Load("temp1.bmp");
	segl.DeriveBlobs(imgseg,pgs,LOWCOLOR,128,EIGHTCONNECTED,1);
	noofglymp=pgs.GetTotalGroups();
	grid_1->AppendRows(noofglymp,TRUE);
	for(int i=1;i<2/*noofglymp-1*/;i++)
	{
	//pgs[i].CopyToImage(1,0,1,imgblob);
	//imgblob.Save("gridtemp.bmp");
	gridbitt->LoadFile("\\ocrproject\\gtamilocr\\gridtemp.bmp",wxBITMAP_TYPE_BMP);
	grid_1->SetCellBitmap(gridbitt, i, 1);
	}
}

