/* segtrain.cpp. This file is part of GNU Tamil OCR
 *
 * GNU Tamil OCR :  <http://gtamilocr.sourceforge.net>
 * Free, Cross-Platform, Optical Character Recognition for Tamil
 *
 * Copyright (C) 2004-2007  Visweswara R, <visweswara@users.sourceforge.net>.
 * All Rights Reserved. DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR
 * THIS FILE HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License version 3 for more details(a copy is included
 * in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "segtrain.h"


MySegTrain::MySegTrain(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxDialog(parent, id, title, pos, size, wxDEFAULT_DIALOG_STYLE)
{
    // begin wxGlade: MySegTrain::MySegTrain
    SegSplitter = new wxSplitterWindow(this, -1);
    segpanel2 = new wxPanel(SegSplitter, -1);
    segpanel1 = new wxPanel(SegSplitter, -1);
    label_3 = new wxStaticText(segpanel1, -1, _("Name of Symbol Displayed :\n"), wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE);
    text_ctrl_2 = new wxTextCtrl(segpanel1, -1, wxT(""));
    Increase = new wxButton(segpanel1, -1, _("+"));
    Decrease = new wxButton(segpanel1, -1, _("-"));
    Save = new wxButton(segpanel1, -1, _("Save"));
    Delete = new wxButton(segpanel1, -1, _("Delete"));
    bitmap_1 = new wxStaticBitmap(segpanel2, -1, wxBitmap(wxT("D:\\temp\\charblob.bmp"), wxBITMAP_TYPE_ANY));

    set_properties();
    do_layout();
    // end wxGlade
}


void MySegTrain::set_properties()
{
    // begin wxGlade: MySegTrain::set_properties
    SetTitle(_("Segment And Train"));
    SetSize(wxSize(424, 294));
    label_3->SetSize(wxSize(235, 60));
    label_3->SetBackgroundColour(wxColour(236, 233, 216));
    text_ctrl_2->SetSize(wxSize(200, 60));
    text_ctrl_2->SetBackgroundColour(wxColour(255, 255, 255));
    text_ctrl_2->SetFont(wxFont(28, wxMODERN, wxNORMAL, wxNORMAL, 0, "TSCMylai"));
    Increase->SetSize(wxSize(30, 30));
    Increase->SetFont(wxFont(16, wxDEFAULT, wxNORMAL, wxNORMAL, 0, ""));
    Decrease->SetSize(wxSize(30, 30));
    Decrease->SetBackgroundColour(wxColour(236, 233, 216));
    Decrease->SetFont(wxFont(16, wxDEFAULT, wxNORMAL, wxNORMAL, 0, ""));
    segpanel1->SetSize(wxSize(203, 256));
    SegSplitter->SplitVertically(segpanel1, segpanel2);
    // end wxGlade
}


void MySegTrain::do_layout()
{
    // begin wxGlade: MySegTrain::do_layout
    wxBoxSizer* sizer_6 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_1 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_7 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_8 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_9 = new wxBoxSizer(wxHORIZONTAL);
    sizer_7->Add(label_3, 0, wxEXPAND, 0);
    sizer_7->Add(text_ctrl_2, 0, 0, 0);
    sizer_9->Add(70, 20, 0, 0, 0);
    sizer_9->Add(Increase, 0, 0, 0);
    sizer_9->Add(Decrease, 0, 0, 0);
    sizer_9->Add(60, 20, 0, 0, 0);
    sizer_7->Add(sizer_9, 1, wxEXPAND, 0);
    sizer_8->Add(30, 20, 0, 0, 0);
    sizer_8->Add(Save, 0, 0, 0);
    sizer_8->Add(Delete, 0, 0, 0);
    sizer_8->Add(50, 20, 0, 0, 0);
    sizer_7->Add(sizer_8, 1, wxEXPAND, 0);
    segpanel1->SetAutoLayout(true);
    segpanel1->SetSizer(sizer_7);
    sizer_1->Add(bitmap_1, 0, wxEXPAND, 0);
    segpanel2->SetAutoLayout(true);
    segpanel2->SetSizer(sizer_1);
    sizer_1->Fit(segpanel2);
    sizer_1->SetSizeHints(segpanel2);
    sizer_6->Add(SegSplitter, 1, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_6);
    Layout();
    // end wxGlade
}

