/* train.cpp. This file is part of GNU Tamil OCR
 *
 * GNU Tamil OCR :  <http://gtamilocr.sourceforge.net>
 * Free, Cross-Platform, Optical Character Recognition for Tamil
 *
 * Copyright (C) 2004-2007  Visweswara R, <visweswara@users.sourceforge.net>.
 * All Rights Reserved. DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR
 * THIS FILE HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License version 3 for more details(a copy is included
 * in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "train.h"


using namespace ipl;

/*Structure to hold the calculated features 16*4 Moment invariants, 1 aspect ratio*/
struct db{

		 double moin[16][4];
	     double hiwi;
		 wxChar ccode[3];
		};

double u00,u01,u10,u11,u20,u02,u21,u12,u30,u03;
double L00,L01,L10,L11,L12,L21,L20,L02,L30,L03;
double i1,i2,i3,i4,m1,m2,m3,m4,yy1,yy2,yy3,yy4;

wxArrayString filenames,paths;
wxString str;
int count;
CImage imgseg;
CImage img;
CSegmentate segl,seg2;
wxString msg;
CFeatures ftl;
CPixelGroups pgs,pgseg;
db *dbarr;
db cdb;
wxFile fil,filtestset;
double f1,f2,f3,f4;

BEGIN_EVENT_TABLE(MyTrain,wxFrame)
EVT_SCROLL(MyTrain::onslide)
EVT_BUTTON(ID_OPENDB,MyTrain::onopendb)
EVT_BUTTON(ID_SEGTRAIN,MyTrain::onsegmentandtrain)
EVT_BUTTON(ID_SAVEAS,MyTrain::onsaveas )
EVT_TEXT_ENTER(ID_TAMILTEXT, MyTrain::ontext)
END_EVENT_TABLE()


MyTrain::MyTrain(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, wxDEFAULT_FRAME_STYLE)
{

    bitmapsegment = new wxStaticBitmap(this, ID_BITSEGEMENT, wxBitmap(wxT("Clear.xpm"), wxBITMAP_TYPE_ANY), wxDefaultPosition, wxDefaultSize, wxSIMPLE_BORDER|wxDOUBLE_BORDER|wxRAISED_BORDER|wxSTATIC_BORDER);
    segmentslide = new wxSlider( this, ID_SLIDESEGMENT, 50, 0, 100, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );

    TamilText = new wxTextCtrl( this,  ID_TAMILTEXT, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0|wxVSCROLL|wxHSCROLL|wxNO_BORDER|wxTE_PROCESS_ENTER|wxWANTS_CHARS );
    TamilText->SetFont( wxFont(30, 70, 90, 90, false, wxEmptyString ) );

    butSegTrain = new wxButton(this, ID_SEGTRAIN, wxT("Segment And Train"));
    butopendb = new wxButton(this, ID_OPENDB, wxT("Open DB"));
    butSaveAs = new wxButton(this, ID_SAVEAS, wxT("TrainSets"));
    butSave = new wxButton(this, ID_SAVE, wxT("Save"));
    set_properties();
    do_layout();


}

void MyTrain::set_properties()
{

    SetTitle(wxT("Segement And Train"));
    SetSize(wxSize(556, 433));
    SetFont(wxFont(20, wxDEFAULT, wxNORMAL, wxNORMAL, 0, wxT("tscarial")));
    bitmapsegment->SetSize(wxSize(64, 64));
    segmentslide->SetSize(wxSize(200, 60));
    TamilText->SetSize(wxSize(120, 64));
    TamilText->SetFont(wxFont(21, wxSCRIPT, wxNORMAL, wxBOLD, 0, wxT("tscarial")));
    butSegTrain->SetSize(wxSize(100, 40));
    butopendb->SetSize(wxSize(100, 40));
    butSaveAs->SetSize(wxSize(100, 40));
    butSave->SetSize(wxSize(100, 40));


}

void MyTrain::do_layout()
{
/*
    wxBoxSizer* sizer_3 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_4 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_6 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_5 = new wxBoxSizer(wxVERTICAL);
    sizer_5->Add(60, 60, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);
    sizer_5->Add(bitmapsegment, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    sizer_5->Add(segmentslide, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    sizer_5->Add(TamilText, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    sizer_4->Add(sizer_5, 1, wxEXPAND, 0);
    sizer_6->Add(20, 64, 0, wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    sizer_6->Add(butSegTrain, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    sizer_6->Add(20, 50, 0, wxEXPAND, 0);
    sizer_6->Add(butopendb, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    sizer_6->Add(20, 50, 0, wxEXPAND, 0);
    sizer_6->Add(butSaveAs, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    sizer_6->Add(20, 50, 0, wxEXPAND, 0);
    sizer_6->Add(butSave, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    sizer_4->Add(sizer_6, 1, wxEXPAND, 0);
    sizer_3->Add(sizer_4, 1, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_3);
    Layout();
    */
    this->SetSizeHints( wxDefaultSize, wxDefaultSize );
	wxBoxSizer* bSizer1;
	bSizer1 = new wxBoxSizer( wxHORIZONTAL );
	wxBoxSizer* bSizer1_1;
	bSizer1_1 = new wxBoxSizer( wxVERTICAL );
	wxBoxSizer* bSizer1_1_1;
	bSizer1_1_1 = new wxBoxSizer( wxVERTICAL );
	bSizer1_1_1->Add( bitmapsegment, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxEXPAND, 5 );
	bSizer1_1->Add( bSizer1_1_1, 5, wxEXPAND, 5 );
	wxBoxSizer* bSizer1_1_2;
	bSizer1_1_2 = new wxBoxSizer( wxVERTICAL );
	bSizer1_1_2->Add( segmentslide, 1, wxALL|wxEXPAND, 5 );
	bSizer1_1->Add( bSizer1_1_2, 1, wxEXPAND, 5 );
	wxBoxSizer* bSizer1_1_3;
	bSizer1_1_3 = new wxBoxSizer( wxVERTICAL );
	bSizer1_1_3->Add( TamilText, 1, wxEXPAND|wxALL|wxALIGN_CENTER_HORIZONTAL, 5 );
	bSizer1_1->Add( bSizer1_1_3, 2, wxEXPAND, 5 );
	bSizer1->Add( bSizer1_1, 1, wxEXPAND, 5 );
	wxBoxSizer* bSizer1_2;
	bSizer1_2 = new wxBoxSizer( wxVERTICAL );
	wxBoxSizer* bSizer1_2_1;
	bSizer1_2_1 = new wxBoxSizer( wxVERTICAL );
	bSizer1_2_1->Add( 0, 0, 1, 0, 5 );
	bSizer1_2->Add( bSizer1_2_1, 1, wxEXPAND, 5 );
	wxBoxSizer* bSizer1_2_2;
	bSizer1_2_2 = new wxBoxSizer( wxVERTICAL );
	bSizer1_2_2->Add( butSegTrain, 0, wxALL|wxALIGN_CENTER_HORIZONTAL, 5 );
	bSizer1_2->Add( bSizer1_2_2, 1, wxEXPAND, 5 );
	wxBoxSizer* bSizer1_2_3;
	bSizer1_2_3 = new wxBoxSizer( wxVERTICAL );
	bSizer1_2_3->Add( butopendb, 0, wxALL|wxALIGN_CENTER_HORIZONTAL, 5 );
	bSizer1_2->Add( bSizer1_2_3, 1, wxEXPAND, 5 );
	wxBoxSizer* bSizer1_2_4;
	bSizer1_2_4 = new wxBoxSizer( wxVERTICAL );
	bSizer1_2_4->Add( butSaveAs, 0, wxTOP|wxBOTTOM|wxALIGN_CENTER_HORIZONTAL, 5 );
	bSizer1_2->Add( bSizer1_2_4, 1, wxEXPAND, 5 );
	wxBoxSizer* bSizer1_2_5;
	bSizer1_2_5 = new wxBoxSizer( wxVERTICAL );
	bSizer1_2_5->Add( butSave, 0, wxALL|wxALIGN_CENTER_HORIZONTAL, 5 );
	bSizer1_2->Add( bSizer1_2_5, 1, wxEXPAND, 5 );
	bSizer1->Add( bSizer1_2, 1, wxEXPAND, 5 );
	this->SetSizer( bSizer1 );
	this->Layout();


}
void MyTrain::ontext(wxCommandEvent &event)
{

	dbarr[segmentslide->GetValue()].ccode[0]=(TamilText->GetValue().GetChar(0));
	dbarr[segmentslide->GetValue()].ccode[1]=(TamilText->GetValue().GetChar(1));
	dbarr[segmentslide->GetValue()].ccode[2]=(TamilText->GetValue().GetChar(2));


	//dbarr[segmentslide->GetValue()].ccode=TamilText->GetLineText(0);

	fil.Write(&(dbarr[segmentslide->GetValue()]),sizeof(dbarr[segmentslide->GetValue()]));
    segmentslide->SetValue((segmentslide->GetValue())+1);
	movetext();

}

void MyTrain::onopendb(wxCommandEvent &event)
{


}

void MyTrain::onsaveas(wxCommandEvent &event)
{
savebitmap();
}
void MyTrain::onslide(wxScrollEvent &event)

{   movetext();
}

void MyTrain::onsegmentandtrain(wxCommandEvent &event)
{
	wxString msg;
	imgseg.Load("temp1.bmp");
	segl.DeriveBlobs(imgseg,pgs,LOWCOLOR,128,EIGHTCONNECTED,1);
	dbarr = new db[pgs.GetTotalGroups()];
	segmentslide->SetRange(0,pgs.GetTotalGroups()-1);
	msg.Printf(wxT("%d"),pgs.GetTotalGroups());
    wxMessageBox(msg,wxT("Total Groups"),wxOK,NULL, -1, -1);
	fil.Open(wxT("temp.txt"),wxFile::write/*wxFile::write_append */);
	fil.Create(wxT("temp.txt"),TRUE,wxS_DEFAULT);
}


void MyTrain::slide()
{
	CImage imgblob;
	wxImage imgblobb;
	pgs[segmentslide->GetValue()].CopyToImage(1,0,1,imgblob);
	imgblob.Save("imgblob.bmp");
	imgblobb.LoadFile(wxT("imgblob.bmp"), wxBITMAP_TYPE_ANY,-1);
	bitmapsegment->SetBitmap(wxBitmap(imgblobb));
        movetext();
}

void MyTrain::movetext()
{

wxString slide;
    CImage imgblob,imgblobtemp;
	CCoordinateTransform ctran;
	CMorphology morp;
	CPixelGroup pg,pge;
	wxString msg;

	int x,y,i,j,k;
	int ref;
	ref=segmentslide->GetValue();
	dbarr[segmentslide->GetValue()].hiwi=1.0000*((double)pgs[ref].GetWidth()/(double)pgs[ref].GetHeight());
	pgs[ref].CopyToImage(1,0,1,imgblob);
	pgs[ref].CopyToImage(1,0,1,imgblobtemp);
	imgblobtemp.SetOrigo(0,0);
	imgblob.SetOrigo(0,0);
	morp.Thinning(imgblobtemp);
	imgblobtemp.SetOrigo(0,0);
	for(i=0;i<imgblobtemp.GetHeight();i++)
		 {
			 for(j=0;j<imgblobtemp.GetWidth();j++)
			 {
				 if(imgblobtemp.GetPixelFast(j,i)==0)
					 pge.AddPosition(j,i);
			 }
    }

	if( (pge.GetWidth()*pge.GetHeight()) >100 )
	{

	ctran.ScaleAuto(imgblob,imgblob,(double)64.1/(double)pgs[ref].GetWidth(),(double)64.1/(double)pgs[ref].GetHeight(),1);
	imgblob.SetOrigo(0,0);
	morp.Thinning(imgblob);
	imgblob.Invert();
	imgblob.SetOrigo(0,0);
     k=0;

     for(i=0;i<64;i=i+16)
	 {
		 for(j=0;j<64;j=j+16)
		 {
		      for(y=i;y<(i+16);y++)
	           {
	          for(x=j;x<(j+16);x++)
		       {
			   if(imgblob.GetPixelFast(x,y)==1)
			   pg.AddPosition(x,y);
		       }
               }
			    pge.CopyToImage(1,0,1,imgblobtemp);
				if(pg.GetTotalPositions()==0)
				{
				dbarr[segmentslide->GetValue()].moin[k][0]=0;
            	dbarr[segmentslide->GetValue()].moin[k][1]=0;
                dbarr[segmentslide->GetValue()].moin[k][2]=0;
             	dbarr[segmentslide->GetValue()].moin[k][3]=0;

				}
				else
				{
			    ftl.DeriveMomentsBinary(pg,3);
                ftl.DeriveCentralMoments();
			   	dbarr[segmentslide->GetValue()].moin[k][0]=.001*(ftl.m_CentrMom.m20+ftl.m_CentrMom.m02);
            	dbarr[segmentslide->GetValue()].moin[k][1]=.001*(sqrt((pow((ftl.m_CentrMom.m20+ftl.m_CentrMom.m02),2)+4*pow(ftl.m_CentrMom.m11,2))) );
                dbarr[segmentslide->GetValue()].moin[k][2]=.001*(sqrt(pow((ftl.m_CentrMom.m30) - (3*ftl.m_CentrMom.m12),2) + pow((3*(ftl.m_CentrMom.m21))-(ftl.m_CentrMom.m03),2)));
             	dbarr[segmentslide->GetValue()].moin[k][3]=.001*(((ftl.m_CentrMom.m30)+(ftl.m_CentrMom.m03)));
				}
			    k++;


		 }
	 }

	 imgblob.Save("imgblob.bmp");
	}

	if((pge.GetWidth()*pge.GetHeight())<=100)
	{
		        if( (pge.GetWidth()*pge.GetHeight())==0)
				{
					pge.AddPosition(0,0);
				}
				ftl.DeriveMomentsBinary(pge,3);
                ftl.DeriveCentralMoments();
				for(k=0;k<16;k++)
				{
			   	dbarr[segmentslide->GetValue()].moin[k][0]=1*(ftl.m_CentrMom.m20+ftl.m_CentrMom.m02);
            	dbarr[segmentslide->GetValue()].moin[k][1]=1*(sqrt((pow((ftl.m_CentrMom.m20+ftl.m_CentrMom.m02),2)+4*pow(ftl.m_CentrMom.m11,2))) );
                dbarr[segmentslide->GetValue()].moin[k][2]=1*(sqrt(pow((ftl.m_CentrMom.m30) - (3*ftl.m_CentrMom.m12),2) + pow((3*(ftl.m_CentrMom.m21))-(ftl.m_CentrMom.m03),2)));
             	dbarr[segmentslide->GetValue()].moin[k][3]=1*(((ftl.m_CentrMom.m30)+(ftl.m_CentrMom.m03)));
				}

				pge.CopyToImage(1,0,1,imgblobtemp);
				imgblobtemp.Save("imgblob.bmp");
			}
	wxImage imgblobb;
	imgblobb.LoadFile(wxT("imgblob.bmp"), wxBITMAP_TYPE_ANY,-1);
	bitmapsegment->SetBitmap(wxBitmap(imgblobb));
	pge.Empty();

}

void MyTrain::segment()
{
	int pgindex;
	CImage imgseg;
	CSegmentate segimg;
	CPixelGroups pggs;
	imgseg.Load("segment.bmp");
	segimg.DeriveBlobs(imgseg,pggs,LOWCOLOR,128,EIGHTCONNECTED,1);
	for(pgindex=0;pgindex<pggs.GetTotalGroups();pgindex++)
	{

    CImage imgblob,imgblobtemp;
	CCoordinateTransform ctran;
	CMorphology morp;
	CPixelGroup pg,pge;
	wxString msg;
	int x,y,i,j,k;
	int ref;
	ref=pgindex;
	cdb.hiwi=(1000.0*((double)pggs[ref].GetWidth()/(double)pggs[ref].GetHeight()));
	double wihi=cdb.hiwi;
	pggs[ref].CopyToImage(1,0,1,imgblob);
	pggs[ref].CopyToImage(1,0,1,imgblobtemp);
	imgblobtemp.SetOrigo(0,0);
	imgblob.SetOrigo(0,0);
	morp.Thinning(imgblobtemp);
	imgblobtemp.SetOrigo(0,0);
	for(i=0;i<imgblobtemp.GetHeight();i++)
		 {
			 for(j=0;j<imgblobtemp.GetWidth();j++)
			 {
				 if(imgblobtemp.GetPixelFast(j,i)==0)
					 pge.AddPosition(j,i);
			 }
         }

	if( (pge.GetWidth()*pge.GetHeight()) >100 )
	{

	ctran.ScaleAuto(imgblob,imgblob,(double)64.1/(double)pggs[ref].GetWidth(),(double)64.1/(double)pggs[ref].GetHeight(),1);
	imgblob.SetOrigo(0,0);
	morp.Thinning(imgblob);
	imgblob.Invert();
	imgblob.SetOrigo(0,0);
     k=0;

     for(i=0;i<64;i=i+16)
	 {
		 for(j=0;j<64;j=j+16)
		 {
		      for(y=i;y<(i+16);y++)
	           {
	          for(x=j;x<(j+16);x++)
		       {
			   if(imgblob.GetPixelFast(x,y)==1)
			   pg.AddPosition(x,y);
		       }
               }
			    pge.CopyToImage(1,0,1,imgblobtemp);
				if(pg.GetTotalPositions()==0)
				{
				cdb.moin[k][0]=0;
            	cdb.moin[k][1]=0;
                cdb.moin[k][2]=0;
             	cdb.moin[k][3]=0;

				}
				else
				{
			    ftl.DeriveMomentsBinary(pg,3);
                ftl.DeriveCentralMoments();

				u00=ftl.m_CentrMom.m00;
				u01=ftl.m_CentrMom.m01;
				u10=ftl.m_CentrMom.m10;
				u11=ftl.m_CentrMom.m11;
				u20=ftl.m_CentrMom.m20;
				u02=ftl.m_CentrMom.m02;
				u21=ftl.m_CentrMom.m21;
				u12=ftl.m_CentrMom.m12;
				u03=ftl.m_CentrMom.m03;
				u30=ftl.m_CentrMom.m30;
				i1=(u20*u02-u11*u11)/pow(u00,4);
				i2=((u30*u30*u03*u03)-(6*u30*u21*u12*u03)+(4*u30*pow(u12,3))+(4*u03*pow(u21,3))-(3*u12*u12*u21*u21))/pow(u00,10);
				i3=( (u20*(u21*u03-(u12*u12)))- (u11*(u30*u03-u21*u12))- ( u02*(u30*u12-u21*u21) ) )/pow(u00,7);
				i4=(pow(u20,3)*pow(u03,2))- (6*u20*u20*u11*u12*u03) - (6*u20*u20*u02*u21*u03) + (9*u20*u20*u02*u12*u12)+ (12*u20*u11*u11*u21*u03);
				i4=i4+(6*u20*u11*u02*u30*u03)-(18*u20*u11*u02*u21*u12)-(8*pow(u11,3)*u30*u03)-(6*u20*u02*u02*u30*u12);
				i4=i4+(9*u20*u02*u02*u21)+(12*u11*u11*u02*u30*u12)-(6*u11*u02*u02*u30*u21)+(pow(u02,3)*u30*u30);
				i4=i4/pow(u00,11);
				m1=u20+u02;
				m2=pow((u20-u02),2)+(4*u11*u11);
				m3=pow((u30-3*u12),2)+pow((3*u21-u03),2);
				m4=pow((u30+u12),2)+pow((u21+u03),2);
				L00=L(0,0,ftl);
				L01=L(0,1,ftl);
				L10=L(1,0,ftl);
				L11=L(1,1,ftl);
				L21=L(2,1,ftl);
				L12=L(1,2,ftl);
				L20=L(2,0,ftl);
				L02=L(0,2,ftl);
				L30=L(3,0,ftl);
				L03=L(0,3,ftl);
				yy1=L20+L02+L00;
				yy2=sqrt(pow((L20-L02),2))+L11;
				yy3=sqrt(pow((L10-L01),2));
				yy4=L30+L03;


			   	cdb.moin[k][0]=yy1*0.1;
            	cdb.moin[k][1]=yy2*0.1;
                cdb.moin[k][2]=yy3*0.1;
				cdb.moin[k][3]=yy4*0.1;

				}
			    k++;
				//pg.EmptyNoDeallocation();

		 }
	 }

	 imgblob.Save("imgblob.bmp");
	}

	if((pge.GetWidth()*pge.GetHeight())<=100)
	{
		        if( (pge.GetWidth()*pge.GetHeight())==0)
				{
					pge.AddPosition(0,0);
				}
				ftl.DeriveMomentsBinary(pge,3);
                ftl.DeriveCentralMoments();
				for(k=0;k<16;k++)
				{

				u00=ftl.m_CentrMom.m00;
				u01=ftl.m_CentrMom.m01;
				u10=ftl.m_CentrMom.m10;
				u11=ftl.m_CentrMom.m11;
				u20=ftl.m_CentrMom.m20;
				u02=ftl.m_CentrMom.m02;
				u21=ftl.m_CentrMom.m21;
				u12=ftl.m_CentrMom.m12;
				u03=ftl.m_CentrMom.m03;
				u30=ftl.m_CentrMom.m30;
				i1=(u20*u02-u11*u11)/pow(u00,4);
				i2=((u30*u30*u03*u03)-(6*u30*u21*u12*u03)+(4*u30*pow(u12,3))+(4*u03*pow(u21,3))-(3*u12*u12*u21*u21))/pow(u00,10);
				i3=( (u20*(u21*u03-(u12*u12)))- (u11*(u30*u03-u21*u12))- ( u02*(u30*u12-u21*u21) ) )/pow(u00,7);
				i4=(pow(u20,3)*pow(u03,2))- (6*u20*u20*u11*u12*u03) - (6*u20*u20*u02*u21*u03) + (9*u20*u20*u02*u12*u12)+ (12*u20*u11*u11*u21*u03);
				i4=i4+(6*u20*u11*u02*u30*u03)-(18*u20*u11*u02*u21*u12)-(8*pow(u11,3)*u30*u03)-(6*u20*u02*u02*u30*u12);
				i4=i4+(9*u20*u02*u02*u21)+(12*u11*u11*u02*u30*u12)-(6*u11*u02*u02*u30*u21)+(pow(u02,3)*u30*u30);
				i4=i4/pow(u00,11);
				m1=u20+u02;
				m2=pow((u20-u02),2)+(4*u11*u11);
				m3=pow((u30-3*u12),2)+pow((3*u21-u03),2);
				m4=pow((u30+u12),2)+pow((u21+u03),2);
				L00=L(0,0,ftl);
				L01=L(0,1,ftl);
				L10=L(1,0,ftl);
				L11=L(1,1,ftl);
				L21=L(2,1,ftl);
				L12=L(1,2,ftl);
				L20=L(2,0,ftl);
				L02=L(0,2,ftl);
				L30=L(3,0,ftl);
				L03=L(0,3,ftl);
				yy1=L20+L02+L00;
				yy2=sqrt(pow((L20-L02),2))+L11;
				yy3=sqrt(pow((L10-L01),2));
				yy4=L30+L03;

			   	cdb.moin[k][0]=yy1*0.1;
            	cdb.moin[k][1]=yy2*0.1;
                cdb.moin[k][2]=yy3*0.1;
				cdb.moin[k][3]=yy4*0.1;
				}

				pge.CopyToImage(1,0,1,imgblobtemp);
				imgblobtemp.Save("imgblob.bmp");
			}
	wxImage imgblobb;
	imgblobb.LoadFile(wxT("imgblob.bmp"), wxBITMAP_TYPE_ANY,-1);
	bitmapsegment->SetBitmap(wxBitmap(imgblobb));

	pge.Empty();




	filtestset.Write(&(cdb),sizeof(cdb));
}
}

void MyTrain::savebitmap()
{

wxString s;
CImage img;
wxFileDialog flg(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.bmp"),wxOPEN|wxMULTIPLE,wxDefaultPosition);
if(flg.ShowModal()==wxID_OK)
{
flg.GetPaths(paths);
flg.GetFilenames(filenames);
count = paths.GetCount();

filtestset.Open("testset.txt",wxFile::write);
/* 2008
for(int i=0;i<count;i++)
{
wxTheApp->Yield();
if(filenames[i].c_str()==(str="001.bmp"))//a
{
    cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="002.bmp"))//aa
{
    cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="003.bmp"))//i
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="005.bmp"))//u
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="007.bmp"))//e
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="009.bmp"))//ai
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="010.bmp"))//o
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}

if(filenames[i].c_str()==(str="011.bmp"))//oo
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="013.bmp"))//ka
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="014.bmp"))//nga
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="015.bmp"))//sa
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();

}

if(filenames[i].c_str()==(str="016.bmp"))//nja
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="017.bmp"))//da
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="018.bmp"))//Na
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="019.bmp"))//dha
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="020.bmp"))//wa
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="021.bmp"))//pa
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="022.bmp"))//ma
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="023.bmp"))//ya
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="024.bmp"))//ra
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="025.bmp"))//la
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="026.bmp"))//va
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="027.bmp"))//za
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="028.bmp"))//La
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="029.bmp"))//Ra
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="030.bmp"))//na
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="031.bmp"))//ki
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="032.bmp"))//ngi
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="033.bmp"))//si
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="034.bmp"))//ngi
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="035.bmp"))//di
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="036.bmp"))//Ni
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="037.bmp"))//dhi
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="038.bmp"))//wi
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="039.bmp"))//pi
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="040.bmp"))//mi
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="041.bmp"))//yi
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="042.bmp"))//ri
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="043.bmp"))//li
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="044.bmp"))//vi
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(TamilText->GetValue()=="")//zi
{
if(filenames[i].c_str()==(str="045.bmp"))
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}
}

if(TamilText->GetValue()=="Ǣ")//Li
{
if(filenames[i].c_str()==(str="046.bmp"))
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}
}


if(filenames[i].c_str()==(str="047.bmp"))//Ri
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="048.bmp"))//ni
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}





if(filenames[i].c_str()==(str="049.bmp"))//kii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="050.bmp"))//njii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="051.bmp"))//sii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="052.bmp"))//njii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="053.bmp"))//dii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="054.bmp"))//Nii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="055.bmp"))//dhii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="056.bmp"))//wii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="057.bmp"))//pii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="058.bmp"))//mii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="059.bmp"))//yii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="060.bmp"))//rii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="061.bmp"))//lii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="062.bmp"))//vii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="063.bmp"))//zii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="064.bmp"))//Lii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="065.bmp"))//Rii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="066.bmp"))//nii
{
 cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="067.bmp"))//ku
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="068.bmp"))//nju
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="069.bmp"))//su
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="070.bmp"))//nju
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="071.bmp"))//du
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="072.bmp"))//Nu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="073.bmp"))//dhu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="074.bmp"))//wu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();

}



if(filenames[i].c_str()==(str="075.bmp"))//pu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="076.bmp"))//mu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="077.bmp"))//yu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="078.bmp"))//ru
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="079.bmp"))//lu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="080.bmp"))//vu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();

}


if(filenames[i].c_str()==(str="081.bmp"))//Lu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="082.bmp"))//Ru
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="083.bmp"))//nu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="084.bmp"))//kuu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="085.bmp"))//njuu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="086.bmp"))//suu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="087.bmp"))//nguu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="088.bmp"))//duu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="089.bmp"))//Nuu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="090.bmp"))//dhuu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="091.bmp"))//wuu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="092.bmp"))//puu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="093.bmp"))//muu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="094.bmp"))//yuu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="095.bmp"))//ruu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="096.bmp"))//zu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="097.bmp"))//lu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="098.bmp"))//vuu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="099.bmp"))//zuu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="100.bmp"))//Luu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="101.bmp"))//Ruu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="102.bmp"))//nuu
{
 cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="103.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}





if(filenames[i].c_str()==(str="104.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="105.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}

if(filenames[i].c_str()==(str="106.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="107.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="108.bmp"))//sha
{
cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="109.bmp"))//ja
{
cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="110.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="111.bmp"))//ha
{
cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="112.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="113.bmp"))//shi
{
cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="114.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="115.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="116.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="117.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="118.bmp"))//shii
{
cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}




if(filenames[i].c_str()==(str="119.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="120.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}



if(filenames[i].c_str()==(str="121.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}


if(filenames[i].c_str()==(str="122.bmp"))
{
cdb.ccode[0]='';
	cdb.ccode[1]='';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}

if(filenames[i].c_str()==(str="123.bmp"))
{
cdb.ccode[0]='.';
	cdb.ccode[1]='\0';
	cdb.ccode[2]='\0';
	img.Load(paths[i].c_str());
	img.Save("segment.bmp");
	segment();
}} */
}

}


