/* train.h. This file is part of GNU Tamil OCR
 *
 * GNU Tamil OCR :  <http://gtamilocr.sourceforge.net>
 * Free, Cross-Platform, Optical Character Recognition for Tamil
 *
 * Copyright (C) 2004-2007  Visweswara R, <visweswara@users.sourceforge.net>.
 * All Rights Reserved. DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR
 * THIS FILE HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License version 3 for more details(a copy is included
 * in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "gtamilocr_utils.h"
#include "global.h"
#include <wx/wx.h>
#include <wx/image.h>
#include <wx/utils.h>
#include <wx/timer.h>
#include <wx/file.h>
#include <wx/wfstream.h>
#include <wx/richtext/richtextctrl.h>
#include <math.h>

#define ID_BITSEGEMENT 50001
#define ID_SLIDESEGMENT 50002
#define ID_TAMILTEXT 50003
#define ID_OPENDB 50004
#define ID_SEGTRAIN 50005
#define ID_SAVEAS 50006
#define ID_SAVE 50007
#define ID_MOVETEXT 50010
#define TAMIL_TEXT_ENTER 70011



#ifndef TRAIN_H
#define TRAIN_H



class MyTrain: public wxFrame {
public:


    MyTrain(wxWindow* parent, int id, const wxString& title, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=wxDEFAULT_FRAME_STYLE);
    void movetext();
private:

    void set_properties();
    void do_layout();
	void onslide(wxScrollEvent &event);

	void onsaveas(wxCommandEvent &event);
	void savebitmap();
	void ontext(wxCommandEvent &event);
	void segment();
	void slide();

	void onsegmentandtrain(wxCommandEvent &event);
	void onopendb(wxCommandEvent &event);



protected:

		wxStaticBitmap* bitmapsegment;
		wxSlider* segmentslide;
		wxTextCtrl* TamilText;

		wxButton* butSegTrain;
		wxButton* butopendb;
		wxButton* butSaveAs;
		wxButton* butSave;

	DECLARE_EVENT_TABLE()

};


#endif

